#require "rdb_concat"

class ExplorerController < ApplicationController 
  layout "gfdnavi"
 
 
 def index 
   session[:previd]=nil
   @previd=nil
   @qargs=nil
   @results=ExplorerResult.new(0)
   @queryconditions=Array.new
   session[:results]=@results
   session[:qsetid]=1
   session[:queryconditions]=@queryconditions
   session[:qcond_selection]=Array.new
   session[:qcno]=0
 end
 
 def add_keyname
     @results=session[:results]
     @results.keynames.push(params[:keyname])
     @results.keynames.uniq!
     session[:results]=@results
     valuelist=@results.get_keyvalue_list(params[:keyname])
     if valuelist.size>0 then
       render :update do |page|
        valuelist.each{ |v|
          page.insert_html(:bottom,"kw_#{params[:keyname]}","<li><a href=\"/explorer/search_kw?keyname=#{params[:keyname]}&keyvalue=#{v.value}\">#{v.value}(#{v.cnt})</a></li>")
        }
       page.show("kw_#{params[:keyname]}_close")       
       end
     end     
 end
 
 def del_keyname
     @results=session[:results]
     @results.keynames.delete(params[:keyname])
     session[:results]=@results
     render :update do |page|
       page.replace_html("kw_#{params[:keyname]}","")
       page.hide("kw_#{params[:keyname]}_close")
     end
 end
 
 def search_path
   @results=session[:results]
   c = Variable.connection.adapter_name=="MySQL" ? "path like concat("'%1'","'%'")" : "'%1'||'%'"
   option={
     :cond=>c,
     :description=>"[P]#{params[:path]}",
   }
   search("path",option)
 end

 def search_freeword
   desc="[F]#{params[:freeword]}"
   option=get_condition4fw(desc)
   search("freeword",option)
 end

 
 def search_kw 
   desc="[K]#{params[:keyname]}=#{params[:keyvalue]}"
   option=get_condition4kw(desc)
   search("keyword",option)
 end
 
  
 def search_kname
   option={
     :cond=>"name = '#{params[:keyname]}'",
     :description=>"[K]#{params[:keyname]}"
   }
   search("keyname",option) 
 end
 
  def search_space    
    desc = "[S](#{params[:start_lon]},#{params[:start_lat]})-(#{params[:end_lon]},#{params[:end_lat]})"
    option=get_condition4space(desc) 
    search("space",option)
 end

  def search_time
   desc="[T]#{params[:starttime]}~params[:endtime]"
   option=get_condition4time(desc)
   search("time",option)
 end
 
=begin
 def back
     @results=session[:results]
#     previd=params[:previd].to_i
#     @previd=previd
#     @results.id=@previd
     session[:previd]=previd
     session[:results]=@results
     render :action=>"index.rhtml"
 end
=end

 def queryconditions_selection
   num=0
   for i in 0..session[:qcno].to_i-1
     if params["qcond_selection_#{i}"]=="1" then
       session[:qcond_selection][i]=1
       num=num+1
     else
       session[:qcond_selection][i]=0
     end
   end
   if num==0 then
     redirect_to :action=>"index"
   else
     search("qcond_selection",params[:queryset_id].to_i)
   end
 end
 
#ꎞIɒ~Bɕ̗\B
=begin  
 def queryset_selection
   num=QueryHistory.find(:first,:select=>"count(*) as cnt",:conditions=>["queryset_id=?",params[:queryset_id].to_i])
   session[:qcond_selection]=Array.new(num.cnt.to_i,1)
   search("qcond_selection",params[:queryset_id].to_i)
 end
=end

 def search(querytype,option)   
   @qsetid=session[:qsetid]
   options=Array.new
   #O̖⍇o
   if session[:queryconditions] then
     @queryconditions=session[:queryconditions]
     @queryconditions.each{ |desc|
        if desc=~/\[(.*)\]/ then
          case $1
          when "K"
            options.push(get_condition4kw(desc))
          when "F"
            options.push(get_condition4fw(desc))
          when "S"
            o=get_condition4space(desc)
            options.push(o)
            spregion=o[:spregion]
          when "T"
            options.push(get_condition4time(desc))
          end
        end               
      }
   else
    @queryconditions=Array.new
   end

  if querytype!="qcond_selection" then
    desc=option[:description] #⍇iۑpj
    conditions=option[:cond]  #⍇ispj
    @queryconditions.push(desc)

    option = options.find{ |o| o[:querytype]==querytype}
    if querytype!="keyword" && querytype!="freeword"  && option
      option[:cond]=conditions
    else
      option = Hash.new
      option[:querytype]=querytype
      option[:cond]=conditions
      options.push(option)
    end
    session[:qcond_selection].push(1)
    session[:qcno]=session[:qcno]+1
   end
  
   #ׂĂ̏킹
    if options then
      allqstr = generate_querystring(options)
   end
   @results=ExplorerResult.new(@qsetid)
   @results.put_results(Node.find_by_sql(allqstr))   
   session[:results]=@results
   render :action=>"index.rhtml"
 end
 
 def generate_querystring(options)
      cnt=0
      sptmky=Array.new
      sptm_qstr_conditions=Array.new
      node_qstr_conditions=Array.new
     
      options.each{ |qh|
        if qh[:querytype] == "keyword" || qh[:querytype]=="keyname" || qh[:querytype] == "freeword" then
          qstr=<<-EOM
            select r.descendant as nid, 'k#{cnt}' as qno, r.rel_depth as relevance
            from keyword_attributes k join node_lineages r on k.node_id = r.ancestor
            where #{qh[:cond]}
          EOM
          sptmky.push(qstr)
          if qh[:querytype] == "freeword" then
            qh[:cond] =~/name like (.*) or/            
            qstr=<<-EOM
              select r.descendant as nid, 'k#{cnt}' as qno, r.rel_depth as relevance
              from nodes n join node_lineages r on n.id = r.ancestor
              where name like #{$1}
            EOM
            sptmky.push(qstr)
          end	
          cnt=cnt+1         
        elsif qh[:querytype]=="space" || qh[:querytype]== "time" then
     	  sptm_qstr_conditions.push(qh[:cond])
     	elsif qh[:querytype]=="path" then
     	  node_qstr_conditions.push(qh[:cond])
        end
      }
     
      if node_qstr_conditions.size>0 then
        node_qstr=<<-EOM
          select r.descendant as nid, 'n' as qno, r.rel_depth as relevance
          from nodes n join node_lineages r on n.id = r.ancestor
          where #{node_qstr_conditions.join(" and ")}
        EOM
        cnt=cnt+1
        sptmky.push(node_qstr)
      end
          
     #spatial_and_time_attributesɂ錟\
     if sptm_qstr_conditions.size>0 then
       sptm_qstr=<<-EOM
         select r.descendant as nid, 's' as qno, r.rel_depth as relevance
         from spatial_and_time_attributes s join node_lineages r on s.node_id = r.ancestor
         where #{sptm_qstr_conditions.join(" and ")}
       EOM
       cnt=cnt+1
       sptmky.push(sptm_qstr)
     end
     
     #̓킹違nodesł̏ipathj킹
     allqstr =<<-EOM
         select n.*, sum(score) as score
         from 
         (select nid,qno,max(relevance) as score
          from (#{sptmky.join(' union all ')}) ar
          group by nid,qno) q join nodes n on q.nid = n.id
          group by nid
          having count(distinct qno)=#{cnt}
          order by sum(score) desc;
     EOM
     return allqstr 
 end
 
 def categorized_results
   results = Hash.new
   options=Array.new
   spregion=[10,-80,350,80]
   if params[:nofquery]!=nil then
     for i in 1..params[:nofquery].to_i do
      if params["query#{i}"]!=nil then
        desc = params["query#{i}"]
        if desc=~/\[(.*)\]/ then
          case $1
          when "K"
            options.push(get_condition4kw(desc))
          when "F"
            options.push(get_condition4fw(desc))
          when "S"
            o=get_condition4space(desc)
            options.push(o)
            spregion=o[:spregion]
          when "T"
            options.push(get_condition4time(desc))
          end
        end        
      end      
     end
		
    if options then
     allqstr = generate_querystring(options)
     
     rnodes=Node.find_by_sql(allqstr)     
     expres=ExplorerResult.new(-1)
     expres.put_results(rnodes)
     
     limit = 100
     if params[:limit]!=nil then
       limit = params[:limit].to_i
     end
     offset = 0
     if params[:offset]!=nil then
       offset = params[:offset].to_i
     end
     
     result_nodes=Array.new
     lcnt=0
     ocnt=0
     rnodes.each{|n|
      if ocnt>=offset then
       node=Hash.new
       node[:type] = Integer=== n.node_type ? Node::NODE_TYPES[n.node_type] : n.node_type
       node[:path] = n.path
       ttl = n.stdname("title")
       node[:title] = ttl ? ttl.value : n.name
       desc = n.stdname("description")
       node[:description] = desc ? desc.value : ''
       node[:name] = n.name
       result_nodes.push(node)      
       lcnt=lcnt+1
      end
      ocnt=ocnt+1
      if lcnt>=limit then
        break
      end
     }
     
     results["nodes"]=result_nodes
     #show keyword facet
     if params["show_kwfacets"].to_i==1 then
       keylist = expres.get_keyname_list
       if keylist!=nil then
         keywords = Array.new
         keylist.each{ |kl|
           keycount = Hash.new
           keycount[:keyname]=kl.kname
           keycount[:count]=kl.cnt
           keywords.push(keycount)
         }
         results["keywords"]=keywords
       end
     end 
     #show spatial facet
     if params["show_spfacets"].to_i==1 then
       spfacets=Hash.new
       results[:spatial_attributes]=spfacets
       points=Array.new
       spfacets[:points]=points
       expres.points(spregion[0],spregion[1],spregion[2],spregion[3]).each{|p|
         pnt=Hash.new
         pnt[:latitude_lb]=p.latitude_lb
         pnt[:longitude_lb]=p.longitude_lb
         pnt[:latitude_rt]=p.latitude_rt
         pnt[:longitude_rt]=p.longitude_rt
         pnt[:count]=p.cnt
         points.push(pnt)
       }
       partial_covered_regions=Array.new
       spfacets[:partial_covered]=partial_covered_regions
       expres.partial_covered(spregion[0],spregion[1],spregion[2],spregion[3]).each{|p|
         rgn=Hash.new
         rgn[:latitude_lb]=p.latitude_lb
         rgn[:longitude_lb]=p.longitude_lb
         rgn[:latitude_rt]=p.latitude_rt
         rgn[:longitude_rt]=p.longitude_rt
         rgn[:count]=p.cnt
         partial_covered_regions.push(rgn)
       }
       all_covered_regions=Array.new
       spfacets[:all_covered]=all_covered_regions
       expres.all_covered(spregion[0],spregion[1],spregion[2],spregion[3]).each{|p|
         rgn=Hash.new
         rgn[:latitude_lb]=p.latitude_lb
         rgn[:longitude_lb]=p.longitude_lb
         rgn[:latitude_rt]=p.latitude_rt
         rgn[:longitude_rt]=p.longitude_rt
         rgn[:count]=p.cnt
         all_covered_regions.push(rgn)
       }
     end
   end
 end

 render :xml => results
 end
 
 def get_condition4kw(description)
   description=~/\[(.*)\](.*)=(.*)/
   qtype=$1
   qname=$2
   qvalue=$3
   options={
     :querytype=>"keyword",
     :cond=>"name = '#{$2}' and value = '#{$3}'",
     :description => description
   }
   return options
 end

 def get_condition4fw(description)
   description=~/\[(.*)\](.*)/
   qtype=$1
   qname=$2
   options={
     :querytype=>"freeword",
     :cond=>"name like '%#{$2}%' or value like '%#{$2}%'",
     :description => description
   }
   return options
 end
 
 def get_condition4time(description)
   description =~/\[T\](.*)~(.*)/
   options={
     :querytype=>"time",
     :cond=>"starttime <= '#{$2}' or endtime >= '#{$1}'",
     :description => description
   }
 end
 
  def get_condition4space(description)
   description=~/\[(.*)\]\((.*),(.*)\)-\((.*),(.*)\)/
  
   start_lon = ( $2 != "" ? $2 : "0" )
   start_lat = ( $3 != "" ? $3 : "-90" )
   end_lon = ( $4 != "" ? $4 : "360" )
   end_lat = ( $5 != "" ? $5 : "90" )

   @dateline=0  # dummy (horinout 2008/07/28): Kept for a while to avoid to be nil, but should be removed in fufure
   
   if start_lon.to_f > end_lon.to_f then
     qcond=<<-EOM
        ( longitude_lb >= #{start_lon} or longitude_rt <= #{end_lon} )
        and latitude_lb <= #{end_lat} and latitude_rt >= #{start_lat} 
        and not(node_id IS NULL)
     EOM
   else
     qcond=<<-EOM
        longitude_lb <= #{end_lon} and longitude_rt >= #{start_lon} 
        and latitude_lb <= #{end_lat} and latitude_rt >= #{start_lat} 
        and not(node_id IS NULL)
     EOM
   end
   options={
     :querytype=>"space",
     :cond=>qcond,
     :description => description
   }
   options[:spregion]=[start_lon,start_lat,end_lon,end_lat]

   return options
 end 
 
end
